import AuditRecord from './auditRecord';
import { EditTask } from './artUtil.js';
import { artApi } from './artApi';

class RepairPlanAudit extends AuditRecord {
    constructor(params) {
        super(params);
        this.repairPlanId = params.repair_plan_id;
        this.reviewerSignatureImage = params.reviewer_signature_image; //审核人签名
        this.status = params.status;
        this.applicantsignatureImage = params.applicant_signature_image; //申请人签名
        this.remark = params.remark;
        this.repairPlan = {
            name: params.repair_plan ? params.repair_plan['name'] : null,
            repairNodes: params.repair_plan ? params.repair_plan['repair_nodes'] : null,
        };
    }
    updateRepairPlanReview(params = {}) {
        let editTask = new EditTask(artApi.repairPlanReviewUpdate);
        editTask.addParam('_id', this.id);
        editTask.addParam('_repair_record_id', this.repairPlanId);
        editTask.addParam('_remark', params.remark);
        editTask.addParam('_status', params.status);

        editTask.addParam('_reviewer_signature_image', params.reviewerSignatureImage);
        return editTask.execute();
    }
}
export default RepairPlanAudit;
